BasicLabelUI (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.plaf.basic, class: BasicLabelUI
Keywords: javax.swing.plaf.basic.BasicLabelUI class

# Class BasicLabelUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.LabelUI
javax.swing.plaf.basic.BasicLabelUI

All Implemented Interfaces:
  `PropertyChangeListener, EventListener`

Direct Known Subclasses:
  `MetalLabelUI, SynthLabelUI`

public class BasicLabelUI extends LabelUI implements PropertyChangeListener
A Windows L&F implementation of LabelUI. This implementation is completely static, i.e. there's only one UIView implementation that's shared by all JLabel objects.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static BasicLabelUI`
  `labelUI`
  The default `BasicLabelUI` instance.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BasicLabelUI()`
  Constructs a `BasicLabelUI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ComponentUI`
  `createUI(JComponent c)`
  Returns an instance of `BasicLabelUI`.
  `int`
  `getBaseline(JComponent c, int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior(JComponent c)`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Dimension`
  `getMaximumSize(JComponent c)`
  Returns the specified component's maximum size appropriate for the look and feel.
  `Dimension`
  `getMinimumSize(JComponent c)`
  Returns the specified component's minimum size appropriate for the look and feel.
  `protected void`
  `installComponents(JLabel c)`
  Registers components.
  `protected void`
  `installDefaults(JLabel c)`
  Installs default properties.
  `protected void`
  `installKeyboardActions(JLabel l)`
  Registers keyboard actions.
  `protected void`
  `installListeners(JLabel c)`
  Registers listeners.
  `protected String`
  `layoutCL(JLabel label, FontMetrics fontMetrics, String text, Icon icon, Rectangle viewR, Rectangle iconR, Rectangle textR)`
  Forwards the call to SwingUtilities.layoutCompoundLabel().
  `void`
  `paint(Graphics g, JComponent c)`
  Paints the label text with the foreground color, if the label is opaque then paints the entire background with the background color.
  `protected void`
  `paintDisabledText(JLabel l, Graphics g, String s, int textX, int textY)`
  Paint clippedText at textX, textY with background.lighter() and then shifted down and to the right by one pixel with background.darker().
  `protected void`
  `paintEnabledText(JLabel l, Graphics g, String s, int textX, int textY)`
  Paint clippedText at textX, textY with the labels foreground color.
  `void`
  `propertyChange(PropertyChangeEvent e)`
  This method gets called when a bound property is changed.
  `protected void`
  `uninstallComponents(JLabel c)`
  Unregisters components.
  `protected void`
  `uninstallDefaults(JLabel c)`
  Uninstalls default properties.
  `protected void`
  `uninstallKeyboardActions(JLabel c)`
  Unregisters keyboard actions.
  `protected void`
  `uninstallListeners(JLabel c)`
  Unregisters listeners.

  ### Methods declared in class ComponentUI

  `contains, getAccessibleChild, getAccessibleChildrenCount, getPreferredSize, installUI, uninstallUI, update`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(JComponent c, int x, int y)`
  Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
  `Accessible`
  `getAccessibleChild(JComponent c, int i)`
  Returns the `i`th `Accessible` child of the object.
  `int`
  `getAccessibleChildrenCount(JComponent c)`
  Returns the number of accessible children in the object.
  `Dimension`
  `getPreferredSize(JComponent c)`
  Returns the specified component's preferred size appropriate for the look and feel.
  `void`
  `installUI(JComponent c)`
  Configures the specified component appropriately for the look and feel.
  `void`
  `uninstallUI(JComponent c)`
  Reverses configuration which was done on the specified component during `installUI`.
  `void`
  `update(Graphics g, JComponent c)`
  Notifies this UI delegate that it is time to paint the specified component.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### labelUI

    protected static BasicLabelUI labelUI
    The default `BasicLabelUI` instance. This field might not be used. To change the default instance use a subclass which overrides the `createUI` method, and place that class name in defaults table under the key "LabelUI".

- ## Constructor Details

  - ### BasicLabelUI

    public BasicLabelUI()
    Constructs a `BasicLabelUI`.

- ## Method Details

  - ### layoutCL

    protected String layoutCL(JLabel label, FontMetrics fontMetrics, String text, Icon icon, Rectangle viewR, Rectangle iconR, Rectangle textR)
    Forwards the call to SwingUtilities.layoutCompoundLabel(). This method is here so that a subclass could do Label specific layout and to shorten the method name a little.
    Parameters:
      `label` - an instance of `JLabel`
      `fontMetrics` - a font metrics
      `text` - a text
      `icon` - an icon
      `viewR` - a bounding rectangle to lay out label
      `iconR` - a bounding rectangle to lay out icon
      `textR` - a bounding rectangle to lay out text
    Returns:
      a possibly clipped version of the compound labels string
    See Also:
      - `SwingUtilities.layoutCompoundLabel(JComponent, FontMetrics, String, Icon, int, int, int, int, Rectangle, Rectangle, Rectangle, int)`

  - ### paintEnabledText

    protected void paintEnabledText(JLabel l, Graphics g, String s, int textX, int textY)
    Paint clippedText at textX, textY with the labels foreground color.
    Parameters:
      `l` - an instance of `JLabel`
      `g` - an instance of `Graphics`
      `s` - a text
      `textX` - an X coordinate
      `textY` - an Y coordinate
    See Also:
      - `paint(Graphics, JComponent)`
      - `paintDisabledText(JLabel, Graphics, String, int, int)`

  - ### paintDisabledText

    protected void paintDisabledText(JLabel l, Graphics g, String s, int textX, int textY)
    Paint clippedText at textX, textY with background.lighter() and then shifted down and to the right by one pixel with background.darker().
    Parameters:
      `l` - an instance of `JLabel`
      `g` - an instance of `Graphics`
      `s` - a text
      `textX` - an X coordinate
      `textY` - an Y coordinate
    See Also:
      - `paint(Graphics, JComponent)`
      - `paintEnabledText(JLabel, Graphics, String, int, int)`

  - ### paint

    public void paint(Graphics g, JComponent c)
    Paints the label text with the foreground color, if the label is opaque then paints the entire background with the background color. The Label text is drawn by `paintEnabledText(JLabel, Graphics, String, int, int)` or `paintDisabledText(JLabel, Graphics, String, int, int)`. The locations of the label parts are computed by `layoutCL(JLabel, FontMetrics, String, Icon, Rectangle, Rectangle, Rectangle)`.
    Overrides:
      `paint` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` context in which to paint
      `c` - the component being painted; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
    See Also:
      - `paintEnabledText(JLabel, Graphics, String, int, int)`
      - `paintDisabledText(JLabel, Graphics, String, int, int)`
      - `layoutCL(JLabel, FontMetrics, String, Icon, Rectangle, Rectangle, Rectangle)`

  - ### getMinimumSize

    public Dimension getMinimumSize(JComponent c)
    Description copied from class: `ComponentUI`
    Returns the specified component's minimum size appropriate for the look and feel. If `null` is returned, the minimum size will be calculated by the component's layout manager instead (this is the preferred approach for any component with a specific layout manager installed). The default implementation of this method invokes `getPreferredSize` and returns that value.
    Overrides:
      `getMinimumSize` in class `ComponentUI`
    Parameters:
      `c` - the component whose minimum size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
    Returns:
      getPreferredSize(c)
    See Also:
      - `JComponent.getMinimumSize()`
      - `LayoutManager.minimumLayoutSize(Container)`
      - `ComponentUI.getPreferredSize(JComponent)`

  - ### getMaximumSize

    public Dimension getMaximumSize(JComponent c)
    Description copied from class: `ComponentUI`
    Returns the specified component's maximum size appropriate for the look and feel. If `null` is returned, the maximum size will be calculated by the component's layout manager instead (this is the preferred approach for any component with a specific layout manager installed). The default implementation of this method invokes `getPreferredSize` and returns that value.
    Overrides:
      `getMaximumSize` in class `ComponentUI`
    Parameters:
      `c` - the component whose maximum size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
    Returns:
      getPreferredSize(c)
    See Also:
      - `JComponent.getMaximumSize()`
      - `LayoutManager2.maximumLayoutSize(Container)`

  - ### getBaseline

    public int getBaseline(JComponent c, int width, int height)
    Returns the baseline.
    Overrides:
      `getBaseline` in class `ComponentUI`
    Parameters:
      `c` - `JComponent` baseline is being requested for
      `width` - the width to get the baseline for
      `height` - the height to get the baseline for
    Returns:
      baseline or a value < 0 indicating there is no reasonable baseline
    Throws:
      `NullPointerException` - if `c` is `null`
      `IllegalArgumentException` - if width or height is < 0
    Since:
      1.6
    See Also:
      - `JComponent.getBaseline(int, int)`

  - ### getBaselineResizeBehavior

    public Component.BaselineResizeBehavior getBaselineResizeBehavior(JComponent c)
    Returns an enum indicating how the baseline of the component changes as the size changes.
    Overrides:
      `getBaselineResizeBehavior` in class `ComponentUI`
    Parameters:
      `c` - `JComponent` to return baseline resize behavior for
    Returns:
      an enum indicating how the baseline changes as the component size changes
    Throws:
      `NullPointerException` - if `c` is `null`
    Since:
      1.6
    See Also:
      - `JComponent.getBaseline(int, int)`

  - ### installDefaults

    protected void installDefaults(JLabel c)
    Installs default properties.
    Parameters:
      `c` - an instance of `JLabel`

  - ### installListeners

    protected void installListeners(JLabel c)
    Registers listeners.
    Parameters:
      `c` - an instance of `JLabel`

  - ### installComponents

    protected void installComponents(JLabel c)
    Registers components.
    Parameters:
      `c` - an instance of `JLabel`

  - ### installKeyboardActions

    protected void installKeyboardActions(JLabel l)
    Registers keyboard actions.
    Parameters:
      `l` - an instance of `JLabel`

  - ### uninstallDefaults

    protected void uninstallDefaults(JLabel c)
    Uninstalls default properties.
    Parameters:
      `c` - an instance of `JLabel`

  - ### uninstallListeners

    protected void uninstallListeners(JLabel c)
    Unregisters listeners.
    Parameters:
      `c` - an instance of `JLabel`

  - ### uninstallComponents

    protected void uninstallComponents(JLabel c)
    Unregisters components.
    Parameters:
      `c` - an instance of `JLabel`

  - ### uninstallKeyboardActions

    protected void uninstallKeyboardActions(JLabel c)
    Unregisters keyboard actions.
    Parameters:
      `c` - an instance of `JLabel`

  - ### createUI

    public static ComponentUI createUI(JComponent c)
    Returns an instance of `BasicLabelUI`.
    Parameters:
      `c` - a component
    Returns:
      an instance of `BasicLabelUI`

  - ### propertyChange

    public void propertyChange(PropertyChangeEvent e)
    Description copied from interface: `PropertyChangeListener`
    This method gets called when a bound property is changed.
    Specified by:
      `propertyChange` in interface `PropertyChangeListener`
    Parameters:
      `e` - A PropertyChangeEvent object describing the event source and the property that has changed.